package game;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import util.Direction;

/**
 * Applet framing for the Bullies game.
 * @author Damian Johnson
 * @version December 10 2007
 */
public class AppletStarter extends JApplet {
  public static final long serialVersionUID = 0;
  
  public void init() {
    setLayout(new BorderLayout());
    final Bullies game = new Bullies();
    
    // Needing to add listener here because %#^(#@*& applets don't respect input/action maps
    game.getDisplay().appletReference = this;
    addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent event) {
        int keycode = event.getKeyCode();
        if (keycode == KeyEvent.VK_UP) game.getDisplay().callMove(Direction.UP);
        else if (keycode == KeyEvent.VK_RIGHT) game.getDisplay().callMove(Direction.RIGHT);
        else if (keycode == KeyEvent.VK_DOWN) game.getDisplay().callMove(Direction.DOWN);
        else if (keycode == KeyEvent.VK_LEFT) game.getDisplay().callMove(Direction.LEFT);
        else if (keycode == KeyEvent.VK_A) {
          game.newGame(null);
          
        }
        else if (keycode == KeyEvent.VK_ENTER) {
          game.nextTurn();
          game.getDisplay().repaint();
        }
      }
    });
    
    /*
    this.addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent event) {
        AppletStarter.this.requestFocus();
        AppletStarter.this.requestFocusInWindow();
      }
    });
    */
    
    setBackground(Color.BLACK);
    add(game.getDisplay());
    
    // New game button
    JButton newgame = new JButton("New Game");
    newgame.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        game.newGame(null);
      }
    });
    
    JPanel bottom = new JPanel(new FlowLayout(FlowLayout.LEFT));
    bottom.add(newgame);
    add(bottom, BorderLayout.SOUTH);
  }
}
