package util;

import java.util.*;

public class Event extends Observable {
    private String name = "Event";
    
    public Event() {}
    public Event(String name) {
        this.name = name;
    }
    
    public void add(Observer o) {
        addObserver(o);
    }
    
    public void remove(Observer o) {
        deleteObserver(o);
    }
    
    public void fire() {
        fire(null);
    }
    
    public void fire(Object arg) {
        setChanged();
        notifyObservers(arg);
    }
    
    public String getName() {
        return this.name;
    }
}
